﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CalendarComboDateLimits85605
{
    public partial class Form1 : Form
    {
        string finalYear = "";

        public Form1()
        {
            InitializeComponent();

            //Set the format for the UltraCalendarCombo
            ultraCalendarCombo1.Format = "dd/mm/yyyy";

            //Example: the cutOff year is set to 50, then:
                //if the incoming year is between 51 and 99, then the final year will return with the prefix of 19; i.e. 30/11/52, will return as 30/11/1952.
                //if the incoming year is between 00 and 50, then the final year will return with the prefix of 20; i.e. 30/11/49, will return as 30/11/2049.

            InterpretDate("30/11/49", 51); //(Input year can be entered in either yy or yyyy format, second parameter is the cutOff year).
            
            //Pass the interpreted date to the ultraCalendarCombo
            ultraCalendarCombo1.Text = finalYear;
        }

        public string InterpretDate(string myDateTime, int cutOffYear)
        {

            string incompleteDate = "", newDate = "";

            string[] parsedDate = System.Text.RegularExpressions.Regex.Split(myDateTime, "/");

            int count = parsedDate[2].Length;

            if (count == 2)
            {
                for (int i = 0; i < 2; i++)
                {
                    incompleteDate += parsedDate[i].ToString() + "/";
                }

                string yearValString = parsedDate[2];
                int yearValInt = Convert.ToInt16(yearValString);

                newDate = incompleteDate + (yearValInt <= cutOffYear ? "20" : "19") + parsedDate[2].ToString();

                finalYear = newDate.ToString();
            }
            
            //if the incoming date already contains the complete year, then there is no need to modify it
            else if (count == 4)
            {
                finalYear = myDateTime;
            }

            return finalYear;
        }
    }
}
